<id>
TPB-PPB
</id>

<version>
1.1
</version>

<mod info>
TPB-PPB ( Topic Preview Box / Post Preview Box )
[ Valid XHTML 1.0 Transitional ]

This version is for SP 1.3.1 & 1.3.2

Please see tpb-ppb_11_README.htm for usage and scrrenshots etc.

Installation 
-------------------------------------------------------------------------------------
- Run tpb-ppb_11.mod with BoardMod 
- Copy the attached Preview.pl to your Sources Directory and chmod 644
- Upload enlish.lng, Admin.pl, AdminEdit.pl, BoardIndex.pl, Load.pl, MessageIndex.pl, Profile, Register.pl and Preview.pl
- Goto forum preferences where you enable and set up the style, width etc.
- Then goto your profile and enable, also advise excisting users to visit their profile and set up these
new settings. New users will have these options enabled as default if admin have enabled
them in forum preferences...

Enjoy !
-------------------------------------------------------------------------------------

Uninstallation 
-------------------------------------------------------------------------------------
Uninstall with BoardMod
Delete Preview.pl.
Done ! 
-------------------------------------------------------------------------------------
</mod info>

<author>
JannoL
</author>

<homepage>
www.jannol.com & forum.j-flames.com
</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";
</search for>

<add after>
# Topic Preview Box / Post Preview Box

$previewtxt{'1'} = "Below";
$previewtxt{'2'} = "Right";
$previewtxt{'3'} = "replies";
$previewtxt{'4'} = "Set Position of Board Description at BoardIndex, Below = Default";
$previewtxt{'5'} = "Number of replies to preview";
$previewtxt{'6'} = "Show Last?";
$previewtxt{'7'} = "No replies yet";
$previewtxt{'8'} = "Enable Post Preview Box";
$previewtxt{'9'} = ", 0 = Preview of Topic creators post only";
$previewtxt{'10'} = "Use Simple Style on Post Preview Box";
$previewtxt{'11'} = "Set Post Preview Box 'Width' in pixels";
$previewtxt{'12'} = "Set Post Preview Box 'Height' in pixels or auto";
$previewtxt{'13'} = ", 0 = default value";
$previewtxt{'14'} = "Post Preview Box Settings";
$previewtxt{'15'} = "Set Post Preview Box 'Left Position' in pixels";
$previewtxt{'16'} = "Enable Topic Preview Box ";
$previewtxt{'17'} = "Set Topic Preview Box 'Width' in pixels";
$previewtxt{'18'} = "Set Topic Preview Box 'Left Position' in pixels";
$previewtxt{'19'} = "Topic Preview Box Settings";
$previewtxt{'20'} = "[ This post preview was snipped because of its size ]";
$previewtxt{'21'} = "Max characters before snipping the Post Preview(s)";
$previewtxt{'22'} = "Number of Post Preview Boxes to use";
$previewtxt{'23'} = "reply";
$previewtxt{'24'} = "Note! You can NOT set Post Preview Box 'Height' when Number of replies is set to 0<br/>(Mozilla 5.0, Firefox and NS always previews the Topic creators post only!)";
$previewtxt{'25'} = "A low number as e.g. 5 is recommended";
$previewtxt{'26'} = "Last Updated Subjects";
$previewtxt{'27'} = "Number of subjects to preview";
$previewtxt{'28'} = "Recent Topics";
$previewtxt{'29'} = "TPB-PPB Settings";
$previewtxt{'30'} = "Board Description Position";
$previewtxt{'31'} = "(This is just an extra function & have nothing to do with TPB-PPB)";
$previewtxt{'32'} = "For Users ? (Users can disable in their profile) ";
$previewtxt{'33'} = "For Guests ?";
</add after>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=modtemp">$txt{'216'}</a><br>
</search for>

<add after>
        - <a href="$cgi;action=previewsettings">$previewtxt{'29'}</a><br />
</add after>

<search for>
	unlink("$memberdir/$currentmem.imconfig");
</search for>

<add after>
	unlink("$memberdir/$currentmem.pbs");
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		}
	}
	my $checkadded = 0;
</search for>

<add before>
			# Topic Preview implement
			require "$sourcedir/Preview.pl";
			&ReadPreviewSettings; # Read preview settings that admin setup for the layout of the Topic Preview Box
			&LoadPBS; # Read user setting to check if he/she enabled the Topic Preview Box
			$yymain =~ m~(.*href="$scripturl\?board=$curboard".*)~i;
			$mbco2_compability = qq~$1~;
			$divboardid = qq~$curcat$curboard$counter~;
			&TPB_PPB_Crossbrowser;
			if ($boarddescposition == 2) { $descpositionright = qq~<font size="1">$curboarddescr</font>~; $descpos = "30%"; $descposnoprev = "70%"; } else { $descpositionbelow = qq~<font size="1">$curboarddescr</font><br />~; $descpos = "100%"; $descposnoprev = "0"; }
			if ($pbssetting[0] eq 'checked' && $tpbusers == 1 && $threadcount{$curboard} != 0 || $username eq 'Guest' && $tpbguests == 1 && $threadcount{$curboard} != 0) {
  			&PreviewTopic($curboard); # actually passing curboard data but it's already checked so no flooding shouldn't be possible
  			$previewbox = qq~<$box id="$divboardid" class="previewborder" style="position:absolute; width:$descwidth; left:$descleft; z-index:1; overflow:visible; display:table; visibility:hidden;">$dispprev</$box>~;
  			$tpbusershtml = qq~
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
				  <tr> 
				    <td valign="top" $divmouseev width="$descpos" height="2">
				    $mbco2_compability
				    </td><td rowspan="3" $divmouseev valign="top" width="$descposnoprev">$previewbox$descpositionright</td>
				  </tr> 
  				<tr> 
    				<td valign="top" onmouseover="document.getElementById('$divboardid').style.visibility='hidden'">$descpositionbelow<font size="1"><i>$showmods</i></font></td> 
  				</tr><tr><td></td></tr> 
				</table>
				~;
			}
			else {
				$tpbusershtml = qq~
				<table border="0" width="100%">
					<tr>
						<td valign="top" width="$descpos">
        						$mbco2_compability
						<br />$descpositionbelow<font size="1"><i>$showmods</i></font></td>
						<td valign="top" width="$descposnoprev">$descpositionright</td>
					</tr>
				</table>~;
			}      
				$yymain =~ s~(<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="\d+%">).*\n?.*\n?.*\n?.*(</td>)~$1$tpbusershtml$2~i;
</add before>

<edit file>
Sources/Load.pl
</edit file>

<search for>
	if($userprofile{$user}->[10] ne "") {
</search for>

<add before>
	&LoadPBS;
	$pbssetting->[0] = $pbssetting->[0] ? qq~$previewtxt{'16'}: $pbssetting->[0]<br />~ : '';
	$pbssetting->[1] = $pbssetting->[1] ? qq~$previewtxt{'8'}: $pbssetting->[1]<br />~ : '';

</add before>

<search for>
sub loadfiles {
</search for>

<add before>
sub LoadPBS {
	if($username ne 'Guest') {
		if (-e("$memberdir/$username.pbs")) {
			fopen(FILE, "$memberdir/$username.pbs");
			@pbssetting = <FILE>;
			fclose(FILE);
		}
		chomp($pbssetting[0]);
		chomp($pbssetting[1]);
	}
}

</add before>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
		$yymain .= qq~
      <tr>
</search for>

<add before>
		# Post Preview Implement, approx. 40 lines ;)
		require "$sourcedir/Preview.pl";
		&ReadPreviewSettings; # Read preview settings that admin setup for the layout of the Post Preview Box
		&LoadPBS; # Read user setting to check if he/she enabled the Post Preview Box
		$pages =~ s~<br>~~gi;
		if ($pbssetting[1] eq 'checked' && $ppbusers == 1 && $counter < $numberofpostpreviews || $username eq 'Guest' && $ppbguests == 1 && $counter < $numberofpostpreviews) {
			$onlypostpreview = 1;
			$divboardid = qq~o$mnum$counter~;
			&TPB_PPB_Crossbrowser;
			if ($mreplies >= 0 && $numberpreviewreplies == 0) { $visible = qq~~; $previewheight = qq~auto~; }	else { $visible = qq~auto~; }
  		&PreviewPost($mnum,$msub,$mreplies,$browser,$pages,$mstate); # actually passing some variables but they are already checked so no flooding shouldn't be possible
			$previewbox = qq~<$box id="$divboardid" class="previewborder" style="position:absolute; width:$previewwidth; height:$previewheight; left:$previewleft; z-index:100; overflow:$visible; display:$disptable; visibility: hidden;">$dispprev</$box>~;
			$hidediv = qq~onmouseover="document.getElementById('$divboardid').style.visibility='hidden'"~;
			$usepostpreviewhtml = qq~
       <table border="0" width="100%" cellspacing="0" cellpadding="0">
       	 <tr>
       		<td $divmouseev>$new <font size="2">$mpoll<a href="$cgi;action=display;num=$mnum"><b>$msub</b></a></font>$has_img$has_attach</td>
       		 <td valign="top" $divmouseev>$previewbox</td>
       		  </tr><tr>
       		 <td colspan="2" valign="bottom" $hidediv><font size="2">$pages</font></td>
      	 </tr>
     	 </table>
      ~;
		}
		else { $divmouseev = qq~~;
			$usepostpreviewhtml = qq~
    	<table border="0" width="100%" cellspacing="0" cellpadding="0">
    		<tr>
    			<td $divmouseev>$new <font size="2">$mpoll<a href="$cgi;action=display;num=$mnum"><b>$msub</b></a></font>$has_img$has_attach</td>
       		<td valign="top" $divmouseev> $previewbox</td>
       	</tr><tr>
       		<td colspan="2" valign="bottom" $hidediv><font size="2">$pages</font></td>
       	</tr>
      </table>~;
    }
    $pages = s~\s*~~;
</add before>

<search for>
		++$counter;
</search for>

<add before>
				$yymain =~ s~(<td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}">).*(</td>)~$1$usepostpreviewhtml$2~i;
</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$yymain .= qq~
<form action="$cgi;action=profile2" method="POST" name="creator">
</search for>

<add before>
	if (-e("$memberdir/$INFO{'username'}.pbs")) {
		fopen(FILE, "$memberdir/$INFO{'username'}.pbs");
		@pbs = <FILE>;
		fclose(FILE);
	}

</add before>

<search for>
	<font size="1">$txt{'664'} <input value="$MaxSigLen" size="3" name="msgCL" disabled></FONT><BR><BR></font></td></tr>
</search for>

<add after>
  ~;
  require "$sourcedir/Preview.pl"; &ReadPreviewSettings;
  if ($tpbusers) { if ($pbs[0] eq 'checked') { $checkedpbs0 = qq~checked=~; }
	  $yymain .= qq~
	  <tr>
	  	<td colspan="2"><hr width="100%" size="1" class="hr" /></td>
	  </tr><tr>
	  	<td width="320"><font size="2"><b>$previewtxt{'16'}:</b></font></td>
			<td><input type="checkbox" name="usertopicprev" value="checked" $checkedpbs0$pbs[0] /></td>
    </tr>
  	~;
  if (!$ppbusers) { $yymain .= qq~<br />~; }
  }
  if ($ppbusers) { if ($pbs[1] eq 'checked') { $checkedpbs1 = qq~checked=~; }
	if (!$tpbusers) { $yymain .= qq~<tr><td colspan="2"><hr width="100%" size="1" class="hr" /></td></tr><tr>~; }
	$yymain .= qq~
	<tr>
		<td width="320"><font size="2"><b>$previewtxt{'8'}:</b></font></td>
		<td><input type="checkbox" name="userpostprev" value="checked" $checkedpbs1$pbs[1] /></td>
  </tr><br/>~;
  }
	$yymain .= qq~
</add after>

<search for>
		&ToHTML($FORM{'hideemail'});
</search for>

<add after>
		&ToHTML($member{'usertopicprev'});
		&ToHTML($member{'userpostprev'});
</add after>

<search for>
	if($newpassemail) {
</search for>

<add before>
		fopen( FILE, ">$memberdir/$member{'username'}.pbs", 1);
		print FILE "$member{'usertopicprev'}\n";
		print FILE "$member{'userpostprev'}\n";
		fclose(FILE);

</add before>

<search for>
	                unlink("$memberdir/$member{'username'}.imconfig");
</search for>

<add after>
	                unlink("$memberdir/$member{'username'}.pbs");
</add after>

<search for>
	                unlink("$memberdir/$username.imconfig");
</search for>

<add after>
	                unlink("$memberdir/$username.pbs");
</add after>

<edit file>
Sources/Sublist.pl
</edit file>

<search for>
'profile',"Profile.pl&ModifyProfile",
</search for>

<add before>
'previewsettings',"Preview.pl&PreviewSettings",
'previewsettings2',"Preview.pl&PreviewSettings2",
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
</search for>

<add after>
		&TPB_PPB_CSS;               # creates a few css for the previewboxes and a links based on excisting link classes ( this is for removing of the tooltips in Opera )
		$curline =~ s~(\<img.*?)alt\=\"(.*?)\"(.*?\>)~$1alt\=\"$2\" title\=\"$2\"$3~ig; # This creates img titles for Opera and Mozilla if there is defined alt texts
</add after>

<search for>
sub Sticky_remove {
</search for>

<add before>
sub TPB_PPB_CSS {	
	# create a new class for the preview boxes based on windowbg2 class
	$previewboxclass = qq~\.previewborder { background-color: $color{'windowbg2'}; padding: 2px; border: 1px solid $color{'bordercolor'}; }~;
	$curline =~ s~(a:hover.*\n*})~$1\n$previewboxclass~i;		
}

sub TPB_PPB_Crossbrowser {
	$browser = $ENV{'HTTP_USER_AGENT'};
	if ($browser =~ m~Netscape~) { $box = qq~fieldset~; } else { $box = qq~div~; }
	if ($browser =~ m~MSIE~ && $browser !~ m~Opera~ && $onlypostpreview) { $hidejumpto = qq~document.forms['jump'].values.style.visibility='hidden'\;~; $showjumpto = qq~document.forms['jump'].values.style.visibility='visible'\;~; }
	if ($browser =~ m~Mozilla/5.0~) { $disptable = qq~table~; $previewheight = qq~auto~; }
	if ($browser =~ m~Opera~ && $onlypostpreview) { $operaheight = $previewheight-150; $operabottom = qq~document.body.style.margin='0 0 $operaheight 0'~; }
	$divmouseev = qq~onmouseover="document.getElementById('$divboardid').style.visibility='visible';$hidejumpto$operabottom" onmouseout="document.getElementById('$divboardid').style.visibility='hidden';$showjumpto"~;
}

</add before>

<edit file>
Sources/Register.pl
</edit file>

<search for>
	print FILE "$FORM{'hideemail'}\n";
	fclose(FILE);
</search for>

<add after>
	# Enable Preview Boxes as default for new users if admin enabled them
	&fatal_error("$txt{'100'})")	if(-e ("$memberdir/$member{'username'}.pbs"));
	fopen( FILE, ">$memberdir/$member{'username'}.pbs");
	print FILE "checked\n";
	print FILE "checked\n";
	fclose(FILE);
</add after>